# EmptyPlatter.py

from gamegrid import *

class EmptyPlatter(Actor):
    def __init__(self, skiLift):
        Actor.__init__(self, "sprites/lift_platter.png")
        self.skiLift = skiLift
        self.posX = skiLift.liftStart[0]
        self.posY = skiLift.liftStart[1]
        self.liftSpeed = skiLift.liftSpeed
        self.liftDirection = skiLift.liftDirection

    def act(self):
        self.setPosition(self.posX + self.liftDirection[0] * self.liftSpeed, 
                         self.posY + self.liftDirection[1] * self.liftSpeed)
        self.setLocation(self.posToLoc())

        if self.posY < 50:
            self.removeSelf()

    def setPosition(self, x, y):
        self.posX = x
        self.posY = y

    def posToLoc(self):
        return Location(int(self.posX), int(self.posY))
