# InfoBoard.py

from threading import Thread
import time
from java.awt import Font, Color

class InfoBoard(Thread):
    def __init__(self, skiResort, skiLift, nbSkiers):
        Thread.__init__(self)
        self.skiResort = skiResort
        self.skiLift = skiLift
        self.nbSkiers = nbSkiers
        self.purgeInfoBoard()

    def run(self):
        while True:
            time.sleep(0.2)
            if self.totalTime == 0:
                continue
            slowSkiersInQueue = self.skiLift.getSlowSkiersInQueue()
            fastSkiersInQueue = self.skiLift.getQueueSize() - slowSkiersInQueue
            averageWaitTimeSlow = self.waitingTimeSlow / self.totalTime
            averageWaitTimeFast = self.waitingTimeFast / self.totalTime
            averageSkiingTimeSlow = self.skiingTimeSlow / self.totalTime
            averageSkiingTimeFast = self.skiingTimeFast / self.totalTime
            averageLiftTimeSlow = self.liftTimeSlow / self.totalTime
            averageLiftTimeFast = self.liftTimeFast / self.totalTime
            self.skiResort.setStatusText("[Time %% waiting,riding,skiing (#descents)]  \
SLOW: [%4.2f%%, %4.2f%%, %4.2f%% (%d)] - \
FAST: [%4.2f%%, %4.2f%%, %4.2f%% (%d)]"
              %(averageWaitTimeSlow, averageLiftTimeSlow, averageSkiingTimeSlow, self.trackCountSlow, 
                averageWaitTimeFast, averageLiftTimeFast, averageSkiingTimeFast, self.trackCountFast),
                Font("SansSerif", Font.BOLD, 15), Color.black)    
   
    def incWaitingTime(self, slow):
        if slow:
            self.waitingTimeSlow += 1
        else:
            self.waitingTimeFast += 1

    def incSkiingTime(self, slow):
        if slow:
            self.skiingTimeSlow += 1
        else:
            self.skiingTimeFast += 1

    def incLiftTime(self, slow):
        if slow:
            self.liftTimeSlow += 1
        else:
            self.liftTimeFast += 1
            
    def incTrackCount(self, slow):
        if slow:
            self.trackCountSlow += 1
        else:   
            self.trackCountFast += 1

    def incTotalTime(self):
        self.totalTime += 0.5 # same for slow and fast
  
    def purgeInfoBoard(self):
        self.totalTime = 0
        self.waitingTimeSlow = 0
        self.waitingTimeFast = 0
        self.skiingTimeSlow = 0
        self.skiingTimeFast = 0
        self.liftTimeSlow = 0
        self.liftTimeFast = 0
        self.trackCountSlow = 0
        self.trackCountFast = 0
